\section{Software Craftsmanship}

\subsection{The Agile Hangover}
\begin{quote}
	«Engineering is the easy part. If we fix the process, engineering will be fixed, managers were told. […] And they bought it.» – Sandro Mancuso, Clean Agile, 2019
\end{quote}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.6\textwidth]{values}
  \caption{How to be a software craftsman}
\end{figure}

\subsection{Values}
A person with a job would say something like: i work as a software developer but a person with a profession would say: i am a software developer.

\textbf{Professionalism:} Take responsibility for your work:
\begin{itemize}
	\itemsep -0.2em
	\item Do no harm to function
	\item Do no harm to structure
	\item Do know that your solution works
	\item Do know that your solution is well designed 
\end{itemize}

You need to have an appropriate work ethic: know your field - but keep learning, practice, also outside your normal job, collaborate and communicate with your team, regularly reflect your attitude and behaviour.

\subsection{Attitudes}
There are different core attitudes to be a successful software engineer.

\subsubsection{Saying NO}
Be honest and say no when you think it is the right thing to do. When you say no, explain the reasons behind and try to offer alternatives. There is no trying - if you are unsure about the outcome, say no!

\subsubsection{Saying YES}
Only say yes if you meant it and you can handle task - it is a commitment. Work hard to keep your promises - this establishes an environment of trust. When you interlocutor uses a non-committal language, insist in explicit statements.

\subsubsection{Coding}
When are you more likely to produce good code? In the middle of the night or at the start of the day? Be physically and psychically prepared for coding.

\begin{itemize}
	\itemsep -0.2em
	\item Pace yourself, avoid rushes and overtime
	\item Allow for regular breaks
	\item Prepare for interruptions (Git, TDD, Pair Programming)
	\item Get help when you get stuck
	\item Do not write code when you are tired
	\item Do not write code when you are distracted or worried
\end{itemize}

\subsubsection{Time Management}
It is impossible to keep the same level of focus for a full workday. Recharge before important work! (Have a good night’s sleep, Drink a cup of coffee / tea, Take a break and chat with your colleague) Try to setup your daily agenda accordingly.

\paragraph{Meetings} \hfill \\
There are two truths about meetings: meetings are necessary, meetings are a huge time waster. As a professional, manage your time carefully.

\begin{itemize}
	\itemsep -0.2em
	\item Only attend meetings that seem valuable
	\item  When declining, be polite and explain reasons
	\item Politely exit meetings not worth your time
	\item Never attend meetings without goal and agenda
	\item As an organizer, never exceed the timebox
\end{itemize}

\paragraph{Blind Alleys}
Have you ever wandered down a technical pathway leading to nowhere or  tried to fix something instead of starting over completely? Following such a blind alley is wasting time. As a professional, have the courage to back out.

\begin{itemize}
	\itemsep -0.2em
	\item Think! about your work (Tip 2)
	\item Do not be afraid to start over
	\item  Get help from your co-workers
	\item Do not beat a dead horse
\end{itemize}

\subsubsection{Pressure}
\begin{quote}
	«Imaging a surgeon is trying to save your life, but time is limited so he is operating under a deadline. How do you want that doctor to behave? \\
	Do you want him calm and collected? Or do you want him sweating and swearing – like a typical developer?» – Robert C. Martin, The Clean Coder, p. 150
\end{quote}

\begin{itemize}
	\itemsep -0.2em
	\item Avoid situations that can cause pressure
	\item Don’t panic (Tip 30)
	\item Keep your normal working behaviour
	\item Communicate that you are in trouble
	\item Get help from your co-workers
	\item Never go for quick and dirty solutions
	\item Never commit to unrealistic deadlines
	\item Do not take responsibility for commitments made by other people
\end{itemize}

\subsubsection{Collaboration}
Software development is all about working with other people. 

\begin{itemize}
	\item Communicate openly and honestly
	\item Be friendly, but take up your position
	\item Never prejudge, accept diversity
	\item Improve your presentation and visualisation skills
	\item It's both what you say and the way you say it
\end{itemize}

\subsubsection{Practicing}
Computer science is a very dynamic industry - make sure you keep your knowledge up to date. Professionals practice, also in their free time.  

\begin{itemize}
	\itemsep -0.2em
	\item Invest regularly
	\item Stay current
	\item Diversify and experiment
	\item Read a bock each quarter
	\item Participate in local user groups
	\item Work on open-source projects
	\item Connect with other developers
\end{itemize}

\subsection{Practices}

\subsubsection{Time Boxing}
Separate your day into focus and non-focus time slots. One approach to do so is the well-known Pomodoro Technique. Make sure nothing interferes with your 25 minutes of focus time. Address all interruptions either in the break or within your next 25-Pomodoro. Fun fact: some Agile teams use number of tomatoes for estimating tasks.

\subsubsection{Coding Katas}
In martial arts, a kata is a set of movements that simulates one side of combat. The goal is to make the movements automatic and instinctive, so they are there when needed.  Likewise, programmers should practice their skills in safe situations to be ready when it counts. An example could be: learning the short cuts for an IDE.

\subsubsection{Coding Dojos}
In Japan, the term dojo describes the place where martial arts are being trained.  Like katas, the term has been adopted to programming and describes a place to practice programming. Idea: learn from each other by doing a kata as a group, often supervised by a Sensei. There are two variants that emerged over time: Wasa - Train as a pair of developers, Randori - train as a group of developers.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{codingdojos}
  \caption{Coding Dojo - Randori}
\end{figure}

\subsubsection{Pair Programming}
Agile software development technique leading to instant reviews. Two programmers working at one PC: the driver writes the code and the navigator gives constant feedback. This causes the two to work on two levels at the same time: the driver focuses on the current task and the navigator focuses on the big picture. It is recommended to switch this roles frequently.
 
 \subsubsection{Rubber Duck Debugging}
 You want to program deliberately, but you can not find the root of a problem? Try explaining the problem to someone else – it often helps finding a solution. This someone does not have to be a human – rubber ducks work very well.
 

  

